# Warren's answer to 121 Assignment 1 Task 1
# (c) 2010 Warren Toomey, GPL 3
#
	 .data
message: .asciiz "Please enter some whole numbers. End with a zero value\n"
prompt:	 .asciiz "Number: "
summsg:	 .asciiz "The sum of the numbers is "
maxmsg:	 .asciiz "The largest number is "
minmsg:	 .asciiz "The smallest number is "
avgmsg:	 .asciiz "The average of the numbers is "
newline: .asciiz "\n"

	.text
					# $v0 is the number entered by the user
					# t0 is the running count
					# $t1 is the running sum
					# $t2 is the running maximum
					# $t3 is the running minimum
					
main:	la $a0, message			# Print out the greeting message using syscall 4
	li $v0, 4
	syscall

					# To make things easier, read one value
					# outside of the loop.
	la $a0, prompt			# Prompt the user
	li $v0, 4
	syscall
	la $v0, 5			# Read an integer into $v0
	syscall
	beqz $v0, endloop		# Stop if user entered a zero
	move $t1, $v0			# Set the running sum, max, min and count
	move $t2, $v0
	move $t3, $v0
	li $t0, 1
	
loop:   la $a0, prompt			# Prompt the user
	li $v0, 4
	syscall
	la $v0, 5			# Read an integer into $v0
	syscall
	beqz $v0, endloop		# Stop if user entered a zero
	
	add $t1, $t1, $v0		# Update the running sum
	blt $v0, $t2, notmax		# Skip if not new maximum
	move $t2, $v0			# otherwise update the maximum
notmax:	bgt $v0, $t3, notmin		# Skip if not new minimum
	move $t3, $v0
notmin:	add $t0, $t0, 1			# Increment the running count
	b loop				# Loop back and do it again

endloop: la $a0, summsg			# Print out the sum message
	li $v0, 4
	syscall
	
	move $a0, $t1			# Move running sum into $a0
	li $v0, 1			# Print out an integer
	syscall
	
	la $a0, newline
	li $v0, 4
	syscall
	
	la $a0, maxmsg			# Print out the max message
	li $v0, 4
	syscall
	
	move $a0, $t2			# Move running max into $a0
	li $v0, 1			# Print out an integer
	syscall
	
	la $a0, newline
	li $v0, 4
	syscall
	
	la $a0, minmsg			# Print out the min message
	li $v0, 4
	syscall
	
	move $a0, $t3			# Move running min into $a0
	li $v0, 1			# Print out an integer
	syscall
	
	la $a0, newline
	li $v0, 4
	syscall
	
	la $a0, avgmsg			# Print out the avg message
	li $v0, 4
	syscall
	
	div $t1, $t0			# Calculate the integer average of sum/count
	mflo $a0			# Print out the quotient
	li $v0, 1			# Print out an integer
	syscall
	
	la $a0, newline
	li $v0, 4
	syscall
	
	li $v0, 10			# Exit the program with syscall 10
	syscall
	
