# Warren's answer to 121 Assignment 1 Task 2
# (c) 2010 Warren Toomey, GPL 3
#
	.data
array:	.word	63, 42, 11, 277, 15, 59, -1143, 75, 37, 49, 29, 373, 87, 6, 68, 58, 7,
		95, 0, 43, 69, 42953, 56, 96, -10, 76645, 873, 27, 90, 84, 90, 79, 47, -18,
		-152, 77, 8, -5, -5, -4506, 35, -9, 89, 52, -9, 94, -12, 5, 26, 48
		 
newline: .asciiz "\n"


	.text					
main:	# Loop to print out the entire array
	li $t0, 0		# Loop for ($t0=0; $t0<50*4; $t0+=4)
loop:	lw $a0, array($t0)	# Get element from array
	li $v0, 1		# Print it out an integer
	syscall
	
	la $a0, newline
	li $v0, 4
	syscall
	
	add $t0, $t0, 4		# Move index up by 4 bytes
	blt $t0, 200, loop	# Branch if $t0 < 50*4
	

	# Code to do Bubble Sort on the array
	# The algorithm is:
	# outside loop: set didswap=0
	#		set X=0
	#		set Y=1
	# inside loop:     if array[X] > array[Y] {
	#                    swap values at X & Y
	#                    set didawap=1
	#                  }
	#                  increment both X and Y
	#                  loop back to inside loop if still inside the array
	#
	#               we did one inside loop,
	#               loop back if didswap is not zero
	#
	# I'm going to use: X is ($t0), Y is 4($t0), didswap is $t2
outsideloop:
	li $t0, 0	# X is 0
	li $t2, 0	# didswap is 0
	
insideloop:
	  lw $t3, array($t0)	# Get X element into $t3
	  lw $t4, array+4($t0)	# Get Y element into $t4
	  ble $t3, $t4, increment	# Do nothing if in the right order
	  sw $t4, array($t0)	# Copy values back so as to swap them
	  sw $t3, array+4($t0)
	  li $t2, 1		# Didswap is now 1
	
increment:
	  add $t0, $t0, 4		# Move X and Y up to next positions
	  blt $t0, 196, insideloop	# Loop back to process next adjacent elements
	  
	beq $t2, 1, outsideloop		# Loop back if we did a swap
		
	# Array is now sorted
	la $a0, newline
	li $v0, 4
	syscall
	
	# Loop to print out the entire array
	li $t0, 0		# Loop for ($t0=0; $t0<50*4; $t0+=4)
loop2:	lw $a0, array($t0)	# Get element from array
	li $v0, 1		# Print it out an integer
	syscall
	
	la $a0, newline
	li $v0, 4
	syscall
	
	add $t0, $t0, 4		# Move index up by 4 bytes
	blt $t0, 200, loop2	# Branch if $t0 < 50*4
	
		
	li $v0, 10		# Exit the program with syscall 10
	syscall
